import * as E from "three";
const x = (
  /* glsl */
  `
    
#ifdef IS_VERTEX
    vec3 csm_Position;
    vec4 csm_PositionRaw;
    vec3 csm_Normal;

    // csm_PointSize
    #ifdef IS_POINTSMATERIAL
        float csm_PointSize;
    #endif
#else
    vec4 csm_DiffuseColor;
    vec4 csm_FragColor;
    float csm_FragColorInfluence;

    // csm_Emissive, csm_Roughness, csm_Metalness
    #if defined IS_MESHSTANDARDMATERIAL || defined IS_MESHPHYSICALMATERIAL
        vec3 csm_Emissive;
        float csm_Roughness;
        float csm_Metalness;
        float csm_Iridescence;
        
        #if defined IS_MESHPHYSICALMATERIAL
            float csm_Clearcoat;
            float csm_ClearcoatRoughness;
            vec3 csm_ClearcoatNormal;
            float csm_Transmission;
            float csm_Thickness;
        #endif
    #endif

    // csm_AO
    #if defined IS_MESHSTANDARDMATERIAL || defined IS_MESHPHYSICALMATERIAL || defined IS_MESHBASICMATERIAL || defined IS_MESHLAMBERTMATERIAL || defined IS_MESHPHONGMATERIAL || defined IS_MESHTOONMATERIAL
        float csm_AO;
    #endif

    // csm_Bump
    #if defined IS_MESHLAMBERTMATERIAL || defined IS_MESHMATCAPMATERIAL || defined IS_MESHNORMALMATERIAL || defined IS_MESHPHONGMATERIAL || defined IS_MESHPHYSICALMATERIAL || defined IS_MESHSTANDARDMATERIAL || defined IS_MESHTOONMATERIAL || defined IS_SHADOWMATERIAL 
        vec3 csm_Bump;
    #endif

    float csm_DepthAlpha;
#endif
`
), O = (
  /* glsl */
  `

#ifdef IS_VERTEX
    // csm_Position & csm_PositionRaw
    #ifdef IS_UNKNOWN
        csm_Position = vec3(0.0);
        csm_PositionRaw = vec4(0.0);
        csm_Normal = vec3(0.0);
    #else
        csm_Position = position;
        csm_PositionRaw = projectionMatrix * modelViewMatrix * vec4(position, 1.);
        csm_Normal = normal;
    #endif

    // csm_PointSize
    #ifdef IS_POINTSMATERIAL
        csm_PointSize = size;
    #endif
#else
    csm_FragColorInfluence = 0.0;

    // csm_DiffuseColor & csm_FragColor
    #if defined IS_UNKNOWN || defined IS_SHADERMATERIAL || defined IS_MESHDEPTHMATERIAL || defined IS_MESHNORMALMATERIAL || defined IS_SHADOWMATERIAL
        csm_DiffuseColor = vec4(1.0, 0.0, 1.0, 1.0);
        csm_FragColor = vec4(1.0, 0.0, 1.0, 1.0);
    #else
        #ifdef USE_MAP
            vec4 _csm_sampledDiffuseColor = texture2D(map, vMapUv);

            #ifdef DECODE_VIDEO_TEXTURE
            // inline sRGB decode (TODO: Remove this code when https://crbug.com/1256340 is solved)
            _csm_sampledDiffuseColor = vec4(mix(pow(_csm_sampledDiffuseColor.rgb * 0.9478672986 + vec3(0.0521327014), vec3(2.4)), _csm_sampledDiffuseColor.rgb * 0.0773993808, vec3(lessThanEqual(_csm_sampledDiffuseColor.rgb, vec3(0.04045)))), _csm_sampledDiffuseColor.w);
            #endif

            csm_DiffuseColor = vec4(diffuse, opacity) * _csm_sampledDiffuseColor;
            csm_FragColor = vec4(diffuse, opacity) * _csm_sampledDiffuseColor;
        #else
            csm_DiffuseColor = vec4(diffuse, opacity);
            csm_FragColor = vec4(diffuse, opacity);
        #endif
    #endif

    // csm_Emissive, csm_Roughness, csm_Metalness
    #if defined IS_MESHSTANDARDMATERIAL || defined IS_MESHPHYSICALMATERIAL
        csm_Emissive = emissive;
        csm_Roughness = roughness;
        csm_Metalness = metalness;

        #ifdef USE_IRIDESCENCE
            csm_Iridescence = iridescence;
        #else
            csm_Iridescence = 0.0;
        #endif

        #if defined IS_MESHPHYSICALMATERIAL
            #ifdef USE_CLEARCOAT
                csm_Clearcoat = clearcoat;
                csm_ClearcoatRoughness = clearcoatRoughness;
            #else
                csm_Clearcoat = 0.0;
                csm_ClearcoatRoughness = 0.0;
            #endif

            #ifdef USE_TRANSMISSION
                csm_Transmission = transmission;
                csm_Thickness = thickness;
            #else
                csm_Transmission = 0.0;
                csm_Thickness = 0.0;
            #endif
        #endif
    #endif

    // csm_AO
    #if defined IS_MESHSTANDARDMATERIAL || defined IS_MESHPHYSICALMATERIAL || defined IS_MESHBASICMATERIAL || defined IS_MESHLAMBERTMATERIAL || defined IS_MESHPHONGMATERIAL || defined IS_MESHTOONMATERIAL
        csm_AO = 0.0;
    #endif

    // csm_Bump
    #if defined IS_MESHLAMBERTMATERIAL || defined IS_MESHMATCAPMATERIAL || defined IS_MESHNORMALMATERIAL || defined IS_MESHPHONGMATERIAL || defined IS_MESHPHYSICALMATERIAL || defined IS_MESHSTANDARDMATERIAL || defined IS_MESHTOONMATERIAL || defined IS_SHADOWMATERIAL 
        csm_Bump = vec3(0.0);
    #endif

    csm_DepthAlpha = 1.0;
#endif
`
), b = (
  /* glsl */
  `
    varying mat4 csm_internal_vModelViewMatrix;
`
), y = (
  /* glsl */
  `
    csm_internal_vModelViewMatrix = modelViewMatrix;
`
), w = (
  /* glsl */
  `
    varying mat4 csm_internal_vModelViewMatrix;
`
), F = (
  /* glsl */
  `
    
`
), R = {
  32: 16777619n,
  64: 1099511628211n,
  128: 309485009821345068724781371n,
  256: 374144419156711147060143317175368453031918731002211n,
  512: 35835915874844867368919076489095108449946327955754392558399825615420669938882575126094039892345713852759n,
  1024: 5016456510113118655434598811035278955030765345404790744303017523831112055108147451509157692220295382716162651878526895249385292291816524375083746691371804094271873160484737966720260389217684476157468082573n
}, N = {
  32: 2166136261n,
  64: 14695981039346656037n,
  128: 144066263297769815596495629667062367629n,
  256: 100029257958052580907070968620625704837092796014241193945225284501741471925557n,
  512: 9659303129496669498009435400716310466090418745672637896108374329434462657994582932197716438449813051892206539805784495328239340083876191928701583869517785n,
  1024: 14197795064947621068722070641403218320880622795441933960878474914617582723252296732303717722150864096521202355549365628174669108571814760471015076148029755969804077320157692458563003215304957150157403644460363550505412711285966361610267868082893823963790439336411086884584107735010676915n
}, H = new globalThis.TextEncoder();
function k(i, n) {
  const a = R[n];
  let o = N[n];
  for (let s = 0; s < i.length; s++)
    o ^= BigInt(i[s]), o = BigInt.asUintN(n, o * a);
  return o;
}
function j(i, n, a) {
  if (a.length === 0)
    throw new Error(
      "The `utf8Buffer` option must have a length greater than zero"
    );
  const o = R[n];
  let s = N[n], c = i;
  for (; c.length > 0; ) {
    const S = H.encodeInto(c, a);
    c = c.slice(S.read);
    for (let r = 0; r < S.written; r++)
      s ^= BigInt(a[r]), s = BigInt.asUintN(n, s * o);
  }
  return s;
}
function B(i, { size: n = 32, utf8Buffer: a } = {}) {
  if (!R[n])
    throw new Error(
      "The `size` option must be one of 32, 64, 128, 256, 512, or 1024"
    );
  if (typeof i == "string") {
    if (a)
      return j(i, n, a);
    i = H.encode(i);
  }
  return k(i, n);
}
const e = {
  // PBR
  diffuse: "csm_DiffuseColor",
  // Color + alpha
  normal: "csm_Normal",
  // Normal
  roughness: "csm_Roughness",
  // Roughness
  metalness: "csm_Metalness",
  // Metalness
  emissive: "csm_Emissive",
  // Emissive
  ao: "csm_AO",
  // AO
  bump: "csm_Bump",
  // Bump
  clearcoat: "csm_Clearcoat",
  // Clearcoat factor
  clearcoatRoughness: "csm_ClearcoatRoughness",
  // Clearcoat roughness
  clearcoatNormal: "csm_ClearcoatNormal",
  // Clearcoat normals
  transmission: "csm_Transmission",
  // Transmission
  thickness: "csm_Thickness",
  // Thickness
  iridescence: "csm_Iridescence",
  // Iridescence
  // Extras
  pointSize: "csm_PointSize",
  fragColor: "csm_FragColor",
  depthAlpha: "csm_DepthAlpha",
  // Depth
  fragColorInfluence: "csm_FragColorInfluence",
  // Unlit factor
  // Vert
  position: "csm_Position",
  positionRaw: "csm_PositionRaw"
}, U = {
  [`${e.position}`]: "*",
  [`${e.positionRaw}`]: "*",
  [`${e.normal}`]: "*",
  [`${e.pointSize}`]: ["PointsMaterial"],
  [`${e.diffuse}`]: "*",
  [`${e.fragColor}`]: "*",
  [`${e.fragColorInfluence}`]: ["*"],
  [`${e.emissive}`]: ["MeshStandardMaterial", "MeshPhysicalMaterial"],
  [`${e.roughness}`]: ["MeshStandardMaterial", "MeshPhysicalMaterial"],
  [`${e.metalness}`]: ["MeshStandardMaterial", "MeshPhysicalMaterial"],
  [`${e.iridescence}`]: [
    "MeshStandardMaterial",
    "MeshPhysicalMaterial"
  ],
  [`${e.ao}`]: [
    "MeshStandardMaterial",
    "MeshPhysicalMaterial",
    "MeshBasicMaterial",
    "MeshLambertMaterial",
    "MeshPhongMaterial",
    "MeshToonMaterial"
  ],
  [`${e.bump}`]: [
    "MeshLambertMaterial",
    "MeshMatcapMaterial",
    "MeshNormalMaterial",
    "MeshPhongMaterial",
    "MeshPhysicalMaterial",
    "MeshStandardMaterial",
    "MeshToonMaterial",
    "ShadowMaterial"
  ],
  [`${e.depthAlpha}`]: ["MeshDepthMaterial"],
  [`${e.clearcoat}`]: ["MeshPhysicalMaterial"],
  [`${e.clearcoatRoughness}`]: ["MeshPhysicalMaterial"],
  [`${e.clearcoatNormal}`]: ["MeshPhysicalMaterial"],
  [`${e.transmission}`]: ["MeshPhysicalMaterial"],
  [`${e.thickness}`]: ["MeshPhysicalMaterial"]
}, V = {
  // VERT
  "*": {
    "#include <lights_physical_fragment>": E.ShaderChunk.lights_physical_fragment,
    "#include <transmission_fragment>": E.ShaderChunk.transmission_fragment
  },
  [`${e.normal}`]: {
    "#include <beginnormal_vertex>": `
    vec3 objectNormal = ${e.normal};
    #ifdef USE_TANGENT
	    vec3 objectTangent = vec3( tangent.xyz );
    #endif
    `
  },
  [`${e.position}`]: {
    "#include <begin_vertex>": `
    vec3 transformed = ${e.position};
  `
  },
  [`${e.positionRaw}`]: {
    "#include <begin_vertex>": `
    vec4 csm_internal_positionUnprojected = ${e.positionRaw};
    mat4x4 csm_internal_unprojectMatrix = projectionMatrix * modelViewMatrix;
    #ifdef USE_INSTANCING
      csm_internal_unprojectMatrix = csm_internal_unprojectMatrix * instanceMatrix;
    #endif
    csm_internal_positionUnprojected = inverse(csm_internal_unprojectMatrix) * csm_internal_positionUnprojected;
    vec3 transformed = csm_internal_positionUnprojected.xyz;
  `
  },
  [`${e.pointSize}`]: {
    "gl_PointSize = size;": `
    gl_PointSize = ${e.pointSize};
    `
  },
  // FRAG
  [`${e.diffuse}`]: {
    "#include <color_fragment>": `
    #include <color_fragment>
    diffuseColor = ${e.diffuse};
  `
  },
  [`${e.fragColor}`]: {
    "#include <dithering_fragment>": `
    #include <dithering_fragment>
    gl_FragColor = mix(gl_FragColor, ${e.fragColor}, ${e.fragColorInfluence});
  `
  },
  [`${e.emissive}`]: {
    "vec3 totalEmissiveRadiance = emissive;": `
    vec3 totalEmissiveRadiance = ${e.emissive};
    `
  },
  [`${e.roughness}`]: {
    "#include <roughnessmap_fragment>": `
    #include <roughnessmap_fragment>
    roughnessFactor = ${e.roughness};
    `
  },
  [`${e.metalness}`]: {
    "#include <metalnessmap_fragment>": `
    #include <metalnessmap_fragment>
    metalnessFactor = ${e.metalness};
    `
  },
  [`${e.ao}`]: {
    "#include <aomap_fragment>": `
    #include <aomap_fragment>
    reflectedLight.indirectDiffuse *= 1. - ${e.ao};
    `
  },
  [`${e.bump}`]: {
    "#include <normal_fragment_maps>": `
    #include <normal_fragment_maps>

    vec3 csm_internal_orthogonal = ${e.bump} - (dot(${e.bump}, normal) * normal);
    vec3 csm_internal_projectedbump = mat3(csm_internal_vModelViewMatrix) * csm_internal_orthogonal;
    normal = normalize(normal - csm_internal_projectedbump);
    `
  },
  [`${e.depthAlpha}`]: {
    "gl_FragColor = vec4( vec3( 1.0 - fragCoordZ ), opacity );": `
      gl_FragColor = vec4( vec3( 1.0 - fragCoordZ ), opacity * ${e.depthAlpha} );
    `,
    "gl_FragColor = packDepthToRGBA( fragCoordZ );": `
      gl_FragColor = packDepthToRGBA( fragCoordZ );
      gl_FragColor.a *= ${e.depthAlpha};
    `
  },
  [`${e.clearcoat}`]: {
    "material.clearcoat = clearcoat;": `material.clearcoat = ${e.clearcoat};`
  },
  [`${e.clearcoatRoughness}`]: {
    "material.clearcoatRoughness = clearcoatRoughness;": `material.clearcoatRoughness = ${e.clearcoatRoughness};`
  },
  [`${e.clearcoatNormal}`]: {
    "#include <clearcoat_normal_fragment_begin>": `
      vec3 csm_coat_internal_orthogonal = csm_ClearcoatNormal - (dot(csm_ClearcoatNormal, nonPerturbedNormal) * nonPerturbedNormal);
      vec3 csm_coat_internal_projectedbump = mat3(csm_internal_vModelViewMatrix) * csm_coat_internal_orthogonal;
      vec3 clearcoatNormal = normalize(nonPerturbedNormal - csm_coat_internal_projectedbump);
    `
  },
  [`${e.transmission}`]: {
    "material.transmission = transmission;": `
      material.transmission = ${e.transmission};
    `
  },
  [`${e.thickness}`]: {
    "material.thickness = thickness;": `
      material.thickness = ${e.thickness};
    `
  },
  [`${e.iridescence}`]: {
    "material.iridescence = iridescence;": `
      material.iridescence = ${e.iridescence};
    `
  }
}, z = {
  clearcoat: [
    e.clearcoat,
    e.clearcoatNormal,
    e.clearcoatRoughness
  ],
  transmission: [e.transmission],
  iridescence: [e.iridescence]
};
function G(i) {
  try {
    new i();
  } catch (n) {
    if (n.message.indexOf("is not a constructor") >= 0)
      return !1;
  }
  return !0;
}
function D(i, n) {
  for (const a in n)
    n[a] instanceof Object && Object.assign(n[a], D(i[a], n[a]));
  return Object.assign(i || {}, n), i;
}
function L(i) {
  return i.replace(/\/\*[\s\S]*?\*\/|\/\/.*/g, "");
}
class W extends E.Material {
  constructor({
    baseMaterial: n,
    vertexShader: a,
    fragmentShader: o,
    uniforms: s,
    patchMap: c,
    cacheKey: S,
    globals: r,
    ...l
  }) {
    let t;
    if (G(n)) {
      const m = Object.keys(l).length === 0;
      t = new n(m ? void 0 : l);
    } else
      t = n, Object.assign(t, l);
    if (["ShaderMaterial", "RawShaderMaterial"].includes(t.type))
      throw new Error(
        `CustomShaderMaterial does not support ${t.type} as a base material.`
      );
    super(), this.uniforms = {}, console.log("NEW");
    const _ = t;
    return _.update = this.update.bind(_), _.uniforms = this.uniforms = s || {}, _.__csm = { baseMaterial: t, patchMap: c }, _.update({
      fragmentShader: o,
      vertexShader: a,
      uniforms: s,
      patchMap: c,
      cacheKey: S,
      globals: r
    }), _;
  }
  update({
    fragmentShader: n,
    vertexShader: a,
    uniforms: o,
    cacheKey: s,
    globals: c,
    patchMap: S
  }) {
    console.log("UPDATE");
    const r = L(a || ""), l = L(n || ""), t = this;
    o && (t.uniforms = o), Object.entries(z).forEach(([_, m]) => {
      for (const u in m) {
        const d = m[u];
        (l && l.includes(d) || r && r.includes(d)) && (t[_] || (t[_] = 1));
      }
    });
    const I = (_, m, u) => {
      var A;
      let d, M = "";
      if (m) {
        const f = /void\s+main\s*\(\s*\)[^{]*{((?:[^{}]+|{(?:[^{}]+|{(?:[^{}]+|{(?:[^{}]+|{[^{}]*})*})*})*})*})/gm;
        d = (A = m.matchAll(f).next().value) == null ? void 0 : A[1];
        const v = m.indexOf("void main() {");
        M = m.slice(0, v);
      }
      return _ = _.replace(
        "void main() {",
        `
        // THREE-CustomShaderMaterial by Faraz Shaikh: https://github.com/FarazzShaikh/THREE-CustomShaderMaterial

        ${u ? w : b}
        ${x}

        ${M}
        
        void main() {
          ${O}
          ${u ? F : y}

          ${c || ""}
          ${d ? `{${d}` : ""}
        `
      ), _;
    };
    t.onBeforeCompile = (_, m) => {
      const d = D(V, S || {}), M = t.__csm.baseMaterial.type, A = M ? `#define IS_${M.toUpperCase()};
` : `#define IS_UNKNOWN;
`;
      _.vertexShader = A + `#define IS_VERTEX
` + _.vertexShader, _.fragmentShader = A + `#define IS_FRAGMENT
` + _.fragmentShader;
      for (const f in d) {
        const T = f === "*" || r && r.includes(f);
        if (f === "*" || l && l.includes(f) || T) {
          const g = U[f];
          if (g && g !== "*" && (Array.isArray(g) ? !g.includes(M) : g !== M)) {
            console.error(
              `CustomShaderMaterial: ${f} is not available in ${M}. Shader cannot compile.`
            );
            return;
          }
          const C = d[f];
          for (const p in C) {
            const h = C[p];
            if (typeof h == "object") {
              const $ = h.type, P = h.value;
              $ === "fs" ? _.fragmentShader = _.fragmentShader.replace(
                p,
                P
              ) : $ === "vs" && (_.vertexShader = _.vertexShader.replace(
                p,
                P
              ));
            } else
              h && (_.vertexShader = _.vertexShader.replace(
                p,
                h
              ), _.fragmentShader = _.fragmentShader.replace(
                p,
                h
              ));
          }
        }
      }
      _.vertexShader = I(
        _.vertexShader,
        r,
        !1
      ), _.fragmentShader = I(
        _.fragmentShader,
        l,
        !0
      ), o && (_.uniforms = { ..._.uniforms, ...t.uniforms }), t.uniforms = _.uniforms;
    }, this.customProgramCacheKey = () => (s == null ? void 0 : s()) || B((r || "") + (l || "")), this.needsUpdate = !0;
  }
}
export {
  W as default
};
//# sourceMappingURL=vanilla.js.map
